/// <reference types="hoist-non-react-statics" />
import React from "react";
import { View, ViewProps } from "react-native";
import { SharedElementAlign, SharedElementAnimation, SharedElementNode, SharedElementResize } from "react-native-shared-element";
import { InjectedStageProps } from "./withStage";
declare type SharedElementConfig = {
    readonly animation: SharedElementAnimation;
    readonly resize?: SharedElementResize;
    readonly align?: SharedElementAlign;
    readonly debug?: boolean;
};
declare type SharedElementActor = {
    node: SharedElementNode;
    config: SharedElementConfig;
};
declare type Actors = {
    [key: string]: SharedElementActor;
};
declare type Props = {
    sceneId: string;
} & InjectedStageProps & ViewProps;
export declare class SceneClass extends React.Component<Props> {
    private _sceneId?;
    private _ancestorNode?;
    private _actors;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    getAncestor(): SharedElementNode | undefined;
    setAncestor(ancestorNode: SharedElementNode | null): void;
    addActor(id: string, actor: SharedElementActor): void;
    removeActor(id: string): void;
    getActors(): Actors;
    onSetRef: (ref: View) => void;
    render(): JSX.Element;
}
declare const _default: {
    (props: any): JSX.Element;
    displayName: string;
    WrappedComponent: typeof SceneClass;
} & import("hoist-non-react-statics").NonReactStatics<typeof SceneClass, {}>;
export default _default;
