import React from "react";
import withStage from "./withStage";
import SceneTransition from "./SceneTransition";
import Transition from "./Transition";
export class SceneTransitionerClass extends React.Component {
    constructor(props) {
        super(props);
        this._transitions = {};
        this.transition = ({ fromId, toId, springConfig = {} }) => {
            const { stage } = this.props;
            let trans = this._transitions[Transition.keyFor(fromId, toId)];
            if (!trans) {
                trans = new Transition(fromId, toId, springConfig, stage, this._handleTransitionReady, this._handleTransitionFinished);
                this._transitions[trans.key] = trans;
            }
            trans.continue();
            return trans;
        };
        this._handleTransitionReady = () => {
            this.setState({
                count: this.state.count + 1
            });
        };
        this._handleTransitionFinished = (trans) => {
            delete this._transitions[trans.key];
            this.setState({
                count: this.state.count + 1
            });
        };
        this.state = {
            count: 0
        };
    }
    render() {
        return (<React.Fragment>
        {Object.keys(this._transitions).map(transKey => {
            return (<SceneTransition key={transKey} transition={this._transitions[transKey]}/>);
        })}
      </React.Fragment>);
    }
}
export default withStage(SceneTransitionerClass);
//# sourceMappingURL=SceneTransitioner.js.map