/// <reference types="hoist-non-react-statics" />
import React from "react";
import { StyleProp, ViewStyle } from "react-native";
import { SharedElementNode, SharedElementAnimation, SharedElementResize, SharedElementAlign } from "react-native-shared-element";
import { InjectedSceneProps } from "./withScene";
declare type Props = {
    sharedId: string;
    animation: SharedElementAnimation;
    resize?: SharedElementResize;
    align?: SharedElementAlign;
    style?: StyleProp<ViewStyle>;
} & InjectedSceneProps;
export declare class SharedElementClass extends React.Component<Props> {
    static defaultProps: {
        animation: string;
    };
    private _node?;
    private _sharedId?;
    constructor(props: Props);
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    onSetNode: (node: SharedElementNode | null) => void;
    render(): JSX.Element;
}
declare const _default: {
    (props: any): JSX.Element;
    displayName: string;
    WrappedComponent: typeof SharedElementClass;
} & import("hoist-non-react-statics").NonReactStatics<typeof SharedElementClass, {}>;
export default _default;
