var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from "react";
import { SharedElement as RawSharedElement } from "react-native-shared-element";
import withScene from "./withScene";
export class SharedElementClass extends React.Component {
    constructor(props) {
        super(props);
        this.onSetNode = (node) => {
            if (this._node === (node || undefined)) {
                return;
            }
            if (this._node && this._sharedId) {
                this.props.scene.removeActor(this._sharedId);
            }
            this._node = node || undefined;
            if (this._node && this._sharedId) {
                this.props.scene.addActor(this._sharedId, {
                    node: this._node,
                    config: {
                        animation: this.props.animation,
                        resize: this.props.resize,
                        align: this.props.align
                    }
                });
            }
            this._node = node || undefined;
        };
        this._sharedId = props.sharedId;
    }
    componentDidUpdate() {
        const { sharedId, scene } = this.props;
        if (this._sharedId !== sharedId) {
            if (this._sharedId && this._node) {
                scene.removeActor(this._sharedId);
            }
            this._sharedId = sharedId;
            if (this._sharedId && this._node) {
                scene.addActor(this._sharedId, {
                    node: this._node,
                    config: {
                        animation: this.props.animation,
                        resize: this.props.resize,
                        align: this.props.align
                    }
                });
            }
        }
    }
    componentWillUnmount() {
        if (this._sharedId && this._node) {
            this.props.scene.removeActor(this._sharedId);
        }
    }
    render() {
        const _a = this.props, { sharedId, animation, resize, align, scene } = _a, rest = __rest(_a, ["sharedId", "animation", "resize", "align", "scene"]);
        return (<RawSharedElement onNode={this.onSetNode} {...rest}>
        {this.props.children}
      </RawSharedElement>);
    }
}
SharedElementClass.defaultProps = {
    animation: "move"
};
export default withScene(SharedElementClass);
//# sourceMappingURL=SharedElement.js.map