import { EndHandler, SpringConfig, StartHandler } from "./types";
import { SceneClass } from "./Scene";
import Animated from "react-native-reanimated";
import Stage from "./Stage";
declare type ReadyHandler = (t: Transition) => void;
declare type FinishedHandler = (t: Transition) => void;
export default class Transition {
    private readonly _key;
    private readonly _fromId;
    private readonly _toId;
    private readonly _animation;
    private readonly _stage;
    private readonly _handleReady;
    private readonly _handleFinished;
    private _fromScene?;
    private _toScene?;
    constructor(fromId: string, toId: string, springConfig: Partial<SpringConfig>, stage: Stage, onReady: ReadyHandler, onFinish: FinishedHandler);
    get key(): string;
    get fromId(): string;
    get toId(): string;
    get fromScene(): SceneClass | undefined;
    get toScene(): SceneClass | undefined;
    get animValue(): Animated.Value<number>;
    get animate(): Animated.Node<number>;
    continue: () => void;
    cancel: () => void;
    onEnterStart: (handler: StartHandler) => void;
    onEnterEnd: (handler: EndHandler) => void;
    onLeaveStart: (handler: StartHandler) => void;
    onLeaveEnd: (handler: EndHandler) => void;
    private _handleAnimationEnd;
    private _handleAddScene;
    static keyFor(fromId: string, toId: string): string;
}
export {};
