var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from "react";
import hoistStatics from "hoist-non-react-statics";
import invariant from "tiny-invariant";
import StageContext from "./StageContext";
export default function withStage(Component) {
    const displayName = `withStage(${Component.displayName || Component.name})`;
    const C = (props) => {
        const { wrappedComponentRef } = props, remainingProps = __rest(props, ["wrappedComponentRef"]);
        return (<StageContext.Consumer>
        {(stage) => {
            invariant(stage, `You should not use <${displayName} /> outside a <Stage>`);
            return (<Component {...remainingProps} stage={stage} ref={wrappedComponentRef}/>);
        }}
      </StageContext.Consumer>);
    };
    C.displayName = displayName;
    C.WrappedComponent = Component;
    return hoistStatics(C, Component);
}
//# sourceMappingURL=withStage.js.map